﻿using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using SyncMVC.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;
using Syncfusion.Linq;

namespace SyncMVC.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {                      
            return View();
        }
        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult KODataSource(DataManager dm)
        {
            ProductCategory s = new ProductCategory();
            IEnumerable clsData = s.GetAll();
            DataResult result = new DataResult();
            DataOperations opt = new DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                foreach (var temp in dm.Sorted)
                    temp.Direction = dm.Sorted[0].Direction == "ascending" ? "Ascending" : "Descending";

                clsData = opt.PerformSorting(clsData, dm.Sorted);

            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                clsData = opt.PerformWhereFilter(clsData, dm.Where, "and"); //Column name and value will be binded in where property
            }            

            var count = clsData.AsQueryable().Count();
            //Paging
            clsData = opt.PerformSkip(clsData, dm.Skip);
            clsData = opt.PerformTake(clsData, dm.Take);
            result.result = clsData;
            result.count = count;
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
    }
}